"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Notify = void 0;
const portal_1 = require("@crysteam/portal");
class Notify {
    constructor(options) {
        this._portal = options.portal;
        this._host = options.host || "https://notify.crysteam.ru";
        this._customScopes = options.scopes;
        this._initialize();
    }
    _initialize() {
        return __awaiter(this, void 0, void 0, function* () {
            const domain = new URL(this._host).hostname;
            this._availableScopes = this._customScopes || (yield this._portal.getServiceScopesFor(domain));
            this._http = this._portal.createHttpClientFor(this._host, this._availableScopes);
        });
    }
    _hasScope(scope) {
        return !!(this._availableScopes && this._portal.isScopeAllowed(this._availableScopes, scope));
    }
    send(payload) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this._http || !this._hasScope({ method: portal_1.Methods.POST, path: "/notify" })) {
                throw new Error("Insufficient permission to notify user.");
            }
            yield this._http.post("/notify", payload);
        });
    }
}
exports.Notify = Notify;
